# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`etcd`](#etcd): Manage etcd

## Classes

### <a name="etcd"></a>`etcd`

Manage etcd

#### Examples

##### 

```puppet
include etcd
```

#### Parameters

The following parameters are available in the `etcd` class:

* [`version`](#-etcd--version)
* [`base_url`](#-etcd--base_url)
* [`os`](#-etcd--os)
* [`arch`](#-etcd--arch)
* [`download_url`](#-etcd--download_url)
* [`download_dir`](#-etcd--download_dir)
* [`extract_dir`](#-etcd--extract_dir)
* [`bin_dir`](#-etcd--bin_dir)
* [`manage_user`](#-etcd--manage_user)
* [`manage_group`](#-etcd--manage_group)
* [`user`](#-etcd--user)
* [`user_uid`](#-etcd--user_uid)
* [`group`](#-etcd--group)
* [`group_gid`](#-etcd--group_gid)
* [`config_path`](#-etcd--config_path)
* [`config`](#-etcd--config)
* [`max_open_files`](#-etcd--max_open_files)

##### <a name="-etcd--version"></a>`version`

Data type: `String`

Version of etcd to install
Not used if download_url is defined.

Default value: `'3.4.7'`

##### <a name="-etcd--base_url"></a>`base_url`

Data type: `Stdlib::HTTPUrl`

Base URL of where to download etcd binaries.
Not used if download_url is defined.

Default value: `'https://github.com/etcd-io/etcd/releases/download'`

##### <a name="-etcd--os"></a>`os`

Data type: `String[1]`

The GOOS to install
Not used if download_url is defined.

Default value: `downcase($facts['kernel'])`

##### <a name="-etcd--arch"></a>`arch`

Data type: `String[1]`

The GOARCH to install
Not used if download_url is defined.

Default value: `$facts['os']['architecture']`

##### <a name="-etcd--download_url"></a>`download_url`

Data type: `Optional[Stdlib::HTTPUrl]`

Alternative location to download etcd binaries

Default value: `undef`

##### <a name="-etcd--download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory of where to download etcd

Default value: `'/tmp'`

##### <a name="-etcd--extract_dir"></a>`extract_dir`

Data type: `Stdlib::Absolutepath`

The directory where to extract etcd

Default value: `'/opt'`

##### <a name="-etcd--bin_dir"></a>`bin_dir`

Data type: `Stdlib::Absolutepath`

The path to bin directory for etcd and etcdctl symlinks

Default value: `'/usr/bin'`

##### <a name="-etcd--manage_user"></a>`manage_user`

Data type: `Boolean`

Boolean that determines if etcd user is managed

Default value: `true`

##### <a name="-etcd--manage_group"></a>`manage_group`

Data type: `Boolean`

Boolean that determines if etcd group is managed

Default value: `true`

##### <a name="-etcd--user"></a>`user`

Data type: `String[1]`

The etcd user

Default value: `'etcd'`

##### <a name="-etcd--user_uid"></a>`user_uid`

Data type: `Optional[Integer]`

The etcd user UID

Default value: `undef`

##### <a name="-etcd--group"></a>`group`

Data type: `String[1]`

The etcd group

Default value: `'etcd'`

##### <a name="-etcd--group_gid"></a>`group_gid`

Data type: `Optional[Integer]`

The etcd group GID

Default value: `undef`

##### <a name="-etcd--config_path"></a>`config_path`

Data type: `Stdlib::Absolutepath`

The path to etcd YAML configuration

Default value: `'/etc/etcd.yaml'`

##### <a name="-etcd--config"></a>`config`

Data type: `Hash`

The config values to pass to etcd

Default value: `{ 'data-dir' => '/var/lib/etcd' }`

##### <a name="-etcd--max_open_files"></a>`max_open_files`

Data type: `Integer`

The value for systemd LimitNOFILE unit option

Default value: `40000`

